<template>
    <div class="app-container calendar-list-container">

        <!-- 查询和其他操作 -->
        <div class="filter-container">
            <el-input clearable class="filter-item" style="width: 200px;" placeholder="标题"
                v-model="listQuery.title"></el-input>
            <el-date-picker
            class="filter-item"
            value-format="yyyy-MM-dd"
            v-model="listQuery.createTime"
            type="date"
            placeholder="创建日期">
            </el-date-picker>
            <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
            <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>

        </div>

        <!-- 查询结果 -->
        <el-table size="small" :data="list" v-loading="listLoading" element-loading-text="正在查询中。。。" border fit
            highlight-current-row>
            <el-table-column type="index" label="序号" header-align="center" align="center">
            </el-table-column>
            <el-table-column align="center" min-width="100px" label="标题" prop="title">
            </el-table-column>
            <el-table-column align="center" min-width="100px" label="简介" prop="subTitle">
            </el-table-column>
            <el-table-column align="center" min-width="80px" label="创建人" prop="sender">
            </el-table-column>
            <el-table-column align="center" min-width="150px" label="创建时间" prop="createTime">
            </el-table-column>
            <el-table-column align="center" min-width="150px" label="定时时间" prop="jobTime">
            </el-table-column>
            
            <el-table-column align="center" min-width="80px" label="状态" prop="statusName">
            </el-table-column>
            <el-table-column align="center" label="操作" width="240px" class-name="small-padding fixed-width">
                <template slot-scope="scope">
                    <el-button type="primary" size="small" @click="handleUpdate(scope.row)">编辑</el-button>
                    <el-button v-if="scope.row.status == 0" type="success" size="small"
                        @click="changeState(scope.row.msgId, 1)">开启</el-button>
                    <el-button v-if="scope.row.status == 1" type="warning" size="small"
                        @click="changeState(scope.row.msgId, 0)">关闭</el-button>
                    <el-button type="danger" size="mini" @click="handleDelete(scope.row.msgId, -1)">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <div class="pagination-container">
            <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
                :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
                layout="total, sizes, prev, pager, next, jumper" :total="total">
            </el-pagination>
        </div>
        <!-- 添加或修改对话框 -->
        <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible" width="70%">
            <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="100px" style='width:700px;margin-left:50px;'>
                <el-form-item label="标题" prop="title">
                    <el-input v-model="dataForm.title" style="width: 350px"></el-input>
                </el-form-item>
                <el-form-item label="简介">
                    <el-input v-model="dataForm.subTitle" style="width: 350px"></el-input>
                </el-form-item>
                <el-form-item style="width: 800px" label="通知图片">
                    <el-upload :action="fileImgUrl" list-type="picture-card" :file-list="dataForm.images" :limit="1"
                            :on-success="handleGallerySucess" :on-exceed="handleExceed" :before-upload="uploadBannerImg"
                            :on-remove="handleRemove">
                            <i class="el-icon-plus"></i>
                    </el-upload>
                        
                </el-form-item>
                <el-form-item label="参与人">
                    <el-select v-model="dataForm.recipients" multiple filterable placeholder="请选择" style="width: 350px">
                        <el-option :key="item.loginId" v-for="item in recipientsList" :label="item.deptName+'_'+item.userName+'_'+item.employeNo" :value="item.loginId">
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="是否定时" prop="timeFlag">
                    <el-radio-group v-model="dataForm.timeFlag">
                        <el-radio :label="1">否</el-radio>
                        <el-radio :label="0">是</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item v-if="dataForm.timeFlag==0" label="定时时间" prop="jobTime">
                    <el-date-picker
                    @change="changeJobTime"
                    style="width: 350px"
                    v-model="dataForm.jobTime"
                    format="yyyy-MM-dd HH:mm:ss"
                    value-format="yyyy-MM-dd HH:mm:ss"
                    type="datetime"
                    placeholder="选择定时时间">
                    </el-date-picker>
                </el-form-item>
                <el-form-item style="width: 800px" label="内容" prop="content">
                    <tinymce v-model="dataForm.content" ref="tinymce"></tinymce>
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button @click="dialogFormVisible = false">取消</el-button>
                <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
                <el-button v-else type="primary" @click="updateData">确定</el-button>
            </div>
        </el-dialog>

    </div>
</template>
  
<style>
.demo-table-expand {
    font-size: 0;
}

.demo-table-expand label {
    width: 200px;
    color: #99a9bf;
}

.demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
}
</style>
  
<script>
import { createItem, updateItem, list, state } from "@/api/noticeList";
import { allUserList } from "@/api/public";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from '@/components/Tinymce'

export default {
    components: { Tinymce },
    directives: { waves },
    data() {
        return {
            fileImgUrl: this.upLoadUrl,
            recipientsList: [],
            list: [],
            total: 0,
            listLoading: false,
            listQuery: {
                page: 1,
                limit: 10,
                title: '',
                createTime: '',
            },
            dataForm: {
                title: '',
                subTitle:'',
                content: '',
                imgUrl: '',
                images: [],
                recipients: [],
                timeFlag:1,
                jobTime:''
            },
            dialogFormVisible: false,
            dialogStatus: '',
            textMap: {
                update: "编辑",
                create: "创建",
            },
            rules: {
                title: [{ required: true, message: "请填写标题名称", trigger: "blur" }],
                content: [{ required: true, message: "内容不能为空", trigger: "blur" }],
                timeFlag: [{ required: true, message: "请选择是否定时", trigger: "blur" }],
                jobTime: [{ required: true, message: "请选择定时时间", trigger: "blur" }],
            },
        }
    },
    created() {
        this.getAllUserList(); 
        this.getList();
    },
    methods: {
        changeJobTime(val){
            console.log(val);
        },
        getAllUserList() {
            allUserList().then(response => {
                this.recipientsList = response.data.data;
            }).catch(() => {});
        },
        handleRemove(file, fileList) {
            console.log(file, fileList);
            let images = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                let url = response.data.url;
                images.push(url);
                this.dataForm.imgUrl = images.join(",");
            }
        },
        uploadBannerImg(file) {
            const isJPGs = file.type === "image/jpeg";
            console.log(isJPGs);
        },
        handleExceed(files, fileList) {
            this.$message.warning(
                `当前限制选择 1 个文件，本次选择了 ${files.length} 个文件！，共选择了 ${files.length + fileList.length
                } 个文件`
            );
        },
        handleGallerySucess(res, file, fileList) {
            this.dataForm.imgUrl = ""; // 清空画廊图片数组

            let images = [];
            for (let i in fileList) {
                let response = fileList[i].response;
                if (response.errno && response.errno != "0") {
                    this.$message.error("该图片上传失败,已被移除,请重新上传!");
                    // 上传失败移除该 file 对象
                    fileList.splice(i, 1);
                } else {
                    let url = response.data.url;
                    images.push(url);
                }
            }

            this.dataForm.imgUrl = images.join(",");
        },
        resetForm() {
            this.dataForm = {
                title: '',
                subTitle:'',
                content: '',
                imgUrl: '',
                recipients: [],
                images: [],
                timeFlag:1,
                jobTime:''
            };
        },
        handleCreate() {

            this.resetForm();
            this.dialogFormVisible = true;
            this.dialogStatus = "create";
            this.$nextTick(() => {
                this.$refs.tinymce.setContent("");
                this.$refs["dataForm"].clearValidate();
            });
        },
        createData() {
            this.$refs["dataForm"].validate((valid) => {
                if (valid) {
                    console.log(this.dataForm);
                    createItem(this.dataForm)
                            .then((response) => {
                                this.getList();
                                this.dialogFormVisible = false;
                                this.$notify({
                                    title: "成功",
                                    message: "创建成功",
                                    type: "success",
                                    duration: 2000,
                                });
                                this.getList();
                            })
                            .catch(() => { });
                }
            });
        },
        handleUpdate(row) {
            this.dataForm = Object.assign({}, row);
            let content = this.dataForm.content;
            if (this.dataForm.imgUrl) {
                let images = this.dataForm.imgUrl.split(",");
                this.dataForm.images = [];
                for (let i in images) {
                    let url = images[i];
                    let name = "image_" + i;

                    this.dataForm.images.push({
                        name: name,
                        url: url,
                        response: { error: "0", data: { url: url } },
                    });
                }
            }
            this.dialogStatus = 'update'
            this.dialogFormVisible = true
            this.$nextTick(() => {
                this.$refs.tinymce.setContent(content);
                this.$refs['dataForm'].clearValidate()
            })
        },
        updateData() {
            this.$refs['dataForm'].validate((valid) => {
                if (valid) {
                    updateItem(this.dataForm).then(() => {
                            this.dialogFormVisible = false
                            this.$notify({
                                title: '成功',
                                message: '更新成功',
                                type: 'success',
                                duration: 2000
                            })
                            this.getList()
                        })

                }

            })
        },
        changeState(msgId, index) {
            state({ msgId: msgId, status: index }).then(response => {
                this.$notify({
                    title: '成功',
                    message: '状态修改成功',
                    type: 'success',
                    duration: 2000
                })
                this.getList()
            })
        },
        handleDelete(msgId, index) {
            this.$confirm('确认删除吗?', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(() => {
                state({ msgId: msgId, status: index }).then(response => {
                    this.$notify({
                        title: '成功',
                        message: '删除成功',
                        type: 'success',
                        duration: 2000
                    })
                    this.getList();
                })
            }).catch(() => {})

        },
        getList() {
            this.listLoading = true
            list(this.listQuery).then(response => {
                this.list = response.data.data.items
                this.total = response.data.data.total
                this.listLoading = false
            }).catch(() => {})
        },
       

        handleFilter() {
            this.listQuery.page = 1
            this.getList()
        },
        handleSizeChange(val) {
            this.listQuery.limit = val
            this.getList()
        },
        handleCurrentChange(val) {
            this.listQuery.page = val
            this.getList()
        },

        
    }
}
</script>
<style>
.ad-avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
    border-color: #409EFF;
}

.ad-avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 178px;
    height: 178px;
    line-height: 178px;
    text-align: center;
}

.ad-avatar {
    display: block;
}
</style>
  